
#declare tgt0 = <1, 0, 0>;
#declare top0 = <0, 0, 1>;
#declare rgt0 = <0, -1, 0>;

#declare Yaw=Camera_Rotation_z * pi / 180;
#declare cosYaw=cos(Yaw);
#declare sinYaw=sin(Yaw);

#declare tgt1 = <cosYaw * tgt0.x - sinYaw * rgt0.x, 
                 cosYaw * tgt0.y - sinYaw * rgt0.y,
                 cosYaw * tgt0.z - sinYaw * rgt0.z>;
#declare rgt1 = <cosYaw * rgt0.x + sinYaw * tgt0.x, 
                 cosYaw * rgt0.y + sinYaw * tgt0.y,
                 cosYaw * rgt0.z + sinYaw * tgt0.z>;
#declare top1 = <top0.x, top0.y, top0.z>;

#declare Pitch=Camera_Rotation_y * pi / 180;
#declare cosPitch=cos(Pitch);
#declare sinPitch=sin(Pitch);

#declare tgt2 = <cosPitch * tgt1.x - sinPitch * top1.x, 
                 cosPitch * tgt1.y - sinPitch * top1.y,
                 cosPitch * tgt1.z - sinPitch * top1.z>;
#declare top2 = <cosPitch * top1.x + sinPitch * tgt1.x, 
                 cosPitch * top1.y + sinPitch * tgt1.y,
                 cosPitch * top1.z + sinPitch * tgt1.z>;
#declare rgt2 = <rgt1.x, rgt1.y, rgt1.z>;

#declare Roll=Camera_Rotation_x * pi / 180;
#declare cosRoll=cos(Roll);                  
#declare sinRoll=sin(Roll);

#declare top3 = <cosRoll * top2.x + sinRoll * rgt2.x, 
                 cosRoll * top2.y + sinRoll * rgt2.y,
                 cosRoll * top2.z + sinRoll * rgt2.z>;
#declare rgt3 = <cosRoll * rgt2.x - sinRoll * top2.x, 
                 cosRoll * rgt2.y - sinRoll * top2.y,
                 cosRoll * rgt2.z - sinRoll * top2.z>;

#declare tgt_org=<Camera_Translate_x - Anchor_Translate_x,
                  Camera_Translate_y - Anchor_Translate_y,
                  Camera_Translate_z - Anchor_Translate_z>;

#declare norm_tgt_org = vlength(tgt_org);
#declare tgt3 = tgt_org/norm_tgt_org;

#declare top4 = top3 - tgt3 * vdot(top3, tgt3);
#declare norm_top4 = vlength(top4);

#declare top4 = top4/norm_top4;

camera {
	perspective
	location<Camera_Translate_x,Camera_Translate_y,Camera_Translate_z>
	look_at<Anchor_Translate_x,Anchor_Translate_y,Anchor_Translate_z>
   	sky top4
	angle CameraAngle
	right -x*image_width/image_height
}
